package bnrobot.core.controller;

import java.io.IOException;
import java.util.Collection;

import jdbm.RecordManager;

import org.apache.lucene.analysis.Analyzer;

import bnrobot.core.Classificator;
import bnrobot.core.Clustering;
import bnrobot.core.DocCollection;
import bnrobot.core.Document;
import bnrobot.core.models.DocumentElement;

public class CollectionController {

	private Analyzer analyzer;

	private RecordManager recman;

	private DocCollection collection;

	private Clustering clustering;

	private Classificator classificator;

	/**
	 * @param analyzer
	 *            the analyzer to set
	 */
	public void setAnalyzer(Analyzer analyzer) {
		this.analyzer = analyzer;
	}

	/**
	 * @return the analyzer
	 */
	public Analyzer getAnalyzer() {
		return analyzer;
	}

	/**
	 * @param recman
	 *            the recman to set
	 */
	public void setRecman(RecordManager recman) {
		this.recman = recman;
	}

	/**
	 * @return the recman
	 */
	public RecordManager getRecman() {
		return recman;
	}

	/**
	 * @param collecction
	 *            the collecction to set
	 */
	public void setCollection(DocCollection collecction) {
		this.collection = collecction;
	}

	/**
	 * @return the collection
	 */
	public DocCollection getCollection() {
		return collection;
	}

	/**
	 * @param clustering
	 *            the clustering to set
	 */
	public void setClustering(Clustering clustering) {
		this.clustering = clustering;
	}

	/**
	 * @return the clustering
	 */
	public Clustering getClustering() {
		return clustering;
	}

	/**
	 * @param classificator
	 *            the classificator to set
	 */
	public void setClassificator(Classificator classificator) {
		this.classificator = classificator;
	}

	/**
	 * @return the classificator
	 */
	public Classificator getClassificator() {
		return classificator;
	}

	public void queueAdd(Document document) {
		new CollectionActor(this).store(document);
	}

	public DocumentElement justProcessDoc(Document document) {
		return new CollectionActor(this).processDoc(document);
	}

	public Collection<DocumentElement> processarFila() {
		return new CollectionActor(this).queueProcess();
	}

	public void recmanCommit() throws IOException {
		this.recman.commit();
		this.recman.clearCache();
	}
}
