package bnrobot.core;

public class ArrayOperations {
	
	public static int unionsSize(int[] a, int[] b) {
		return a.length + b.length - intersectionSize(a, b);
	}
	
	public static int intersectionSize(int[] a, int[] b) {
		int pa=0;
		int pb=0;
		int intersection = 0;
		
		while(pa < a.length && pb < b.length) {
			if( a[pa] > b[pb] ) {
				pb++;
			} else if( a[pa] < b[pb] ) {
				pa++;
			} else {
				intersection++;
				pa++;
				pb++;
			}
		}
		return intersection;
	}	

}
